/*Ŀ
 ݳ Program Name: TEST.PRG          Copyright: Public Domain             
 ݳ Date Created: July 1992          Language: Clipper 5.0               
 ݳ Time Created: Late Night           Author: Kevin S Gallagher         
 ݳ Alterations.: Fixed bugs/and changes made according to Greg Lief     
 ݳ               findings, except for some errors I could not produce   
 
             */

#include "include1.ch"
#define MrGrump                                  // Need Grump.lib
STATIC aDir, aNew
#ifdef MrGrump
#include "GRUMP.CH"
#endif

function DirBrowser
   local jj, x, b, c
   local TRUE := .T., key :=0
   local oldcur:= setcursor(0)
   local FileExt,FileName, element
   local SaveFullScreen()
   dMain()
   **************************************************************************
   * Use TBrowse to view working directory *
   **************************************************************************
   element := 1
   showcurdir()
   tbpanel()                                     // screen for TBrowse
   BK_TICKINS(0,70)                              // install clock
   b:= TBrowseNew(3, 40, maxrow()-2, maxcol()-1)
   b:colorSpec:="W+/B,N/BG,GR+/B"
   b:colSep   := CHR(179)
   b:goTopBlock   := {||  element := 1 }
   b:goBottomBlock:= {||  element := len(aNew) }
   b:skipBlock :=    {|n| ArraySkip(len(aNew), @element, n) }
   c:=TBColumnNew(,{||    PadUm(aNew[element,1],aNew[element,5],element) } )
   c:width:= 12
   b:AddColumn( c )
   c:=TBColumnNew(,{|| aNew[element, 2] } )
   c:width:= 9
   b:AddColumn( c )
   c:=TBColumnNew(,{|| aNew[element, 3] } )
   c:width:= 8
   b:AddColumn( c )
   c:=TBColumnNew(,{|| SUBS(aNew[element,4],1,5)+SUBS(aNew[element,4],7,1)})
   c:width:= 6
   b:AddColumn( c )
   b:freeze := 3
   BEGIN SEQUENCE
      DO WHILE TRUE
         b:colorRect(    { b:rowPos, 1, b:rowPos, b:colCount } , { 1 , 1 } )
         STABILIZE b
         do while .not. b:stabilize()          ;     enddo
         if b:stabilize()
            b:colorRect( { b:rowPos, 1, b:rowPos, b:colCount } , { 2 , 2 } )
            *
            * If you own GRUMP.LIB then define MrGrump
            * #define MrGrump
            * Otherwise the RainHead() udf is used.
            * (You could of course recode it to your specs!)
            *
            #ifdef MrGrump
               INKEY TIMEOUT 60
               key := ginkey(0)
            #else
               while ((key := inkey(.1)) == 0)
                   RainHead()                       // novelty function
               enddo
            #endif
         endif
         DO CASE
           case key == K_UP            ;     b:up()
           case key == K_DOWN          ;     b:down()
           case key == K_PGDN          ;     b:pageDown()
           case key == K_PGUP          ;     b:pageUp()
           case key == K_HOME          ;     b:goTop()
           case key == K_END           ;     b:goBottom()
           case key == K_F1            ;     GetHelp()
           case key == K_ALT_F1        ;     BK_ENV()
           case key == K_F10           ;     break
           case key == K_ALT_F4        ;     break
           case key == K_ALT_F2
               GetDrives()
               dMain()
               InfoBox()
               b:refreshall()
           case key == K_ALT_T
               @5,1  say PADC("WORKING",37)   color "W+*/RB"
               gTree()                           // show DIR tree
               *
               * b:refreshall() is not needed if the
               * user did not CD to a new directory,
               * but it does not slow thing down much!
               *
               b:refreshall()
               dispbox(5,1,22,37,B_SINGLE+" ","B/B")
               dMain()
               InfoBox()
            case key == K_F4
               DO CASE
                  case aNew[element,ELETYPE] = AFILES
                     if val(aNew[element,2]) < 65250
                        EditText(aNew[element,FNAME], .T. )  // edit file
                     else
                        tone(25)
                     endif
               ENDCASE
            case key == K_ENTER
               DO CASE
                  case aNew[element,ELETYPE] = NOTHS
                     dMain()
                     b:refreshall()
                  case aNew[element,ELETYPE] = PARDIR
                     PARENTDIR()                 // CD to parent directory
                     dMain()
                     b:refreshall()
                  case aNew[element,ELETYPE] = ANYDIR
                     FT_CHDIR(aNew[element,1])   // CD to subdirectory
                     dMain()
                     b:goTop()
                     b:refreshall()
                  case aNew[element,ELETYPE] = AFILES
                     **************************************************
                     * Check file .ext and see what to do with it *
                     **************************************************
                     IF AT(".",aNew[element,FNAME] ) >0
                        FileExt := alltrim(substr(aNew[element,FNAME],;
                             AT(".",aNew[element,FNAME]) +1,3;
                           );
                        )
                        FOR jj = 1 to LEN(FILELISTS)
                           IF FILELISTS[jj,1] = FileExt     .AND.           ;
                              FILELISTS[jj,2] = VIEWIT
                              ASCIIVIEW(aNew[element,FNAME]) // View file
                              EXIT
                           ELSEIF FILELISTS[jj,1] = FileExt .AND.           ;
                              FILELISTS[jj,2] = VIEWSP
                              do case
                              case FileExt="dbf" ; DVIEW(aNew[element,FNAME])
                              case FileExt="db"  ; PMain(aNew[element,FNAME])
                              case FileExt="zip" ; ZVIEW(aNew[element,FNAME])
                              endcase
                              EXIT
                           ENDIF
                        NEXT
                     ELSEIF AT(".",aNew[element,FNAME] ) = 0
                        ASCIIVIEW(aNew[element,FNAME]) // View file
                     ENDIF
               ENDCASE
         ENDCASE
      ENDDO
   END SEQUENCE
   setcursor(oldcur)
   BK_TICKREM()                                  // uninstall clock
   RestFullScreen()
   if !file("\NUL")                              // Is drive still ready?
       setcolor("W/N")
       scroll()
       alert( " "+FT_DEFAULT()+">  DRIVE NOT READY  ",,"W+/B,BG+/N" )
   endif
return nil

function Padum( aParm,aType, ele )
   local x := aParm
   * Display TBrowse 1st column
   if aType = PARDIR .OR. aType = ANYDIR
      x := aParm
   elseif AT(".",aNew[ele, 1]) > 0 .AND. aType = AFILES
      x:=PADR(ALLTRIM( substr(aNew[ele, 1],1,AT(".",aNew[ele,1])-1 ) ),9)+;
         SUBSTR(aNew[ele, 1],RAT(".",aNew[ele, 1])+1,3)
   else
      x:=aNew[ele, 1]
   endif
return ( x )

function PARENTDIR
   FT_CHDIR("..")
return nil

Function ChkKeys( pn_Mode, pn_Element, pn_Pos)
    local nKey  := 0, nRVal := 0, n_Key
    DO CASE
        case pn_mode = 0          ; nRVal = 2
        case pn_mode = 1          ; keyboard chr(K_CTRL_PGDN)  ;  nRVal = 2
        case pn_mode = 2          ; keyboard chr(K_CTRL_PGUP)  ;  nRVal = 2
        case pn_mode = 3          ; n_Key = lastkey()
             do case
                 case n_key = 27  ; nRVal = 0
                 case n_key = 13  ; nRVal = 1
                 otherwise        ; nRVal = 3
             endcase
        OTHERWISE                 ; nRVal = 2
    ENDCASE
Return(nRVal)

function BugOut
    setcolor("w/n")
    scroll()
    quit
return Nil

*****************************************************************************
* Fill array with current directory information *
*****************************************************************************
function dMain
    local element, x,b,c, key :=0
    local nNumberOfItems
    local aArr   := {}
    local oldcur := setcursor(0)
    aArr := DIRECTORY("*.*", "D")
    nNumberOfItems := IF( VALTYPE( aArr ) != "A", 0, LEN( aArr ) )
    if nNumberOfItems < 1
       AADD(aArr,{" ",TOPDIR,CTOD("        "),TIME(),"P","X"} )
       aNew:=ACLONE(aArr)
    endif
    aDir:={}
    aNew:={}
    showcurdir()
    AEVAL( aArr, {|aFile| AADD(aDir,aFile[F_NAME]) } )
    *************************************************************************
    * Change military time to civilian base time *
    *************************************************************************
    for x = 1 to LEN(aArr)
        aArr[x,4] := FT_MIL2CIV( STRTRAN(SUBSTR( aArr[x,4],1,5), ":",""))
    next
    *************************************************************************
    * Put parent directory into the first element *
    *************************************************************************
    for x = 1 to LEN(aArr)
        IF aArr[x,5] = "D" .AND.  substr(aArr[x,1],1,2) = ".."
            AADD(aNew,{PAD(aArr[x,FNAME],FFNAME), UPROOT,;
                     PADR(aArr[x,FDATE],FFDATE),;
                  PADR(aArr[x,FTIME],FFTIME),;
               PARDIR,"X";
             };
           )
        endif
    next
    ASORT(aArr,,,DSORTS)                         // sort A-Z
    for x = 1 to LEN(aArr)
        IF aArr[x,5] = "D" .AND. ALLTRIM(SUBSTR(aArr[x,1],1,1)) != "."
            AADD(aNew,{PADR(aArr[x,FNAME],FFNAME), THEDIR,;
                     PADR(aArr[x,FDATE],FFDATE),;
                 PADR(aArr[x,FTIME],FFTIME),;
               ANYDIR,"X";
              };
            )
        endif
    next
    for x = 1 to LEN(aArr)                       // add files to the array
        IF aArr[x,5] !="D"  .AND. AT(".",aArr[x,FNAME])  <> 0
            AADD(aNew,{PADR(LOWER(aArr[x,FNAME]),FFNAME),;
                       PADL(aArr[x,FSIZE],FFSIZE),;
                     PADR(aArr[x,FDATE],FFDATE),; 
                  PADR(aArr[x,FTIME],FFTIME),;
                AFILES,"X";
              };
            )
        elseif aArr[x,5] !="D"  .AND. AT(".",aArr[x,FNAME])  = 0
            AADD(aNew,{LOWER(aArr[x,FNAME]),;
                       PADL(aArr[x,FSIZE],FFSIZE),;
                     PADR(aArr[x,FDATE],FFDATE),; 
                  PADR(aArr[x,FTIME],FFTIME),;
                AFILES,"X";
              };
            )
        endif
    next
    MEMORY(0)
    setcursor(oldcur)
return nil

****************************************************************************
* Show all available drives into a selection box *
****************************************************************************
function GetDrives
    local nTr :=6, nTc :=42, nBr :=14, nChk:= 102
    local DrRow := nTr+4, cols :=nTc+3
    local SaveFullScreen(), x, xx
    local aDrives :={}
    local cFloppie:= BK_NUMDRV()
    local nChoice := 1
    local cHome   := FT_DEFAULT()
    local oldcolor:=setcolor()

    do case                                      // Get floppies
        case cFloppie = 2    ;   aDrives := { " A ", " B " }
        case cFloppie = 1    ;   aDrives := { " A " }
    endcase

    FOR x = 67 to 90                             // get logical drives
        if FT_DEFAULT(chr(x)) = chr(x)
            aadd(aDrives," "+chr(x)+" ")
        endif
    NEXT
    FT_DEFAULT(cHome)
    setcolor('w+/r,gr+/n')
    *********************************************************************
    * Make sure the drive selection box will fit on the screen *
    *********************************************************************
    if LEN(aDrives) >=14
        nTc := 20                                // Default is 42
    endif
    NCBox(nTr+2,nTc+2,nBr-2,(LEN(aDrives) * 2 ) + nTc+4)
    for x = 1 to LEN(aDrives)
        @ DrRow,cols prompt aDrives[x]
        cols := cols + 2
    next
    set wrap on
    menu to nChoice
    setcolor(oldcolor)
    RestFullScreen()
    if nChoice < 1 .or. lastkey() = K_ESC
        FT_DEFAULT(cHome)
        dMain()
        return nil
    endif
    xx := ASC(FT_DEFAULT(substr(aDrives[nChoice],2,1)) )
    RestFullScreen()
    *
    * need to log onto A> or B> when no
    * files or directories are present!
    *
    if xx = 65
        nChk:= DrvReady(cHome, 0 )
        IF nChk = 102
           FT_DEFAULT(cHome)
           dMain()
           return nil
        ENDIF
    elseif xx = 66
        nChk:= DrvReady(cHome, 1 )
        IF nChk = 102
           FT_DEFAULT(cHome)
           dMain()
           return nil
        ENDIF
    else                                         // Fix-Disk
        FT_DEFAULT(substr(aDrives[nChoice],2,1))
        dMain()
        Keyboard chr(27)
    endif
return nil

function DrvReady(cDrive, nDrive )
    local iStatus:=FT_FLOPTST( nDrive )
    do case
        case iStatus == 1   ; cMesg(DOOROP,cDrive)
        case iStatus == 2   ; cMesg(FORDSK,cDrive)
        case iStatus == 3   ; cMesg(WRITPR,cDrive)
        case iStatus == 4   ; cMesg("UNKNOWN ERROR WITH FLOPPY DRIVE",cDrive)
        otherwise
        if nDrive = 0 
           IF LEN(DIRECTORY("A:*.*", "D")) <> 0
              FT_DEFAULT("A")
           ELSE
              return 102
           ENDIF
        elseif nDrive = 1
           IF LEN(DIRECTORY("B:*.*", "D")) <> 0
              FT_DEFAULT("B")
           ELSE
              return 102
           ENDIF
        endif
    endcase
return 0

function showcurdir
    @24,00 say PADR(" "+CURDRV+":\"+CURDIR(CURDRV),80) color "W+/BG"
    @24,71 say "F1 - Help"                             color "W+/BG"
return nil

function cMesg( cMsg, cDrive )
    * Send message from UDF DrvReady()
    ALERT( cMsg )
    * log-on drive (hope it is ready as before)....
    FT_DEFAULT(cDrive)
return nil

*****************************************************************************
* Create a FAT box ala Peter Nortons Norton Commander *
*****************************************************************************
Function NCBox(nTr,nTc,nBr,nBc,color1,color2)
    DEFAULT color1 TO "GR+/R"
    DEFAULT color2 TO "R+/R"
    DISPBOX(nTr-1,nTc-2,nBr+1,nBc+2, B_DOUBLE+" " , color1)
    DISPBOX(nTr,  nTc,  nBr,  nBc,   B_SINGLE+" " , color2)
Return Nil

function Proper( s )
return upper(left(s,1)) + substr(s,2)

function InfoBox                                 // Left Menu Panel
    local cPatt := "999,999,999"
    @ 8,2     say PADL(LTRIM(STR(FT_SYSMEM())),4)               color 'gr+/b'
    @ 8,col() say " Conventional Memory installed"              color 'w+ /b'
    @ 9,2     say PADL(LTRIM(TRANSFORM(FT_DSKSIZE(),cPatt)),17) color 'gr+/b'
    @ 9,col() say " Total Bytes"                                color 'w+ /b'
    @10,2     say PADL(LTRIM(TRANSFORM(FT_DSKFREE(),cPatt)),17) color 'gr+/b'
    @10,col() say " Bytes free"                                 color 'w+ /b'
return nil


#ifdef FANCY
****************************************************************************
* This function mimics FUNCKYs CLS() UDF  CLS2(31,OBJS[6]) *
****************************************************************************
FUNCTION CLS2( nAttr, cPattern )
    LOCAL ShowPat:= "", PatLen, jj
    nAttr   :=IF( ISCOLOR(), nAttr, 7)
    nAttr   :=IF( EMPTY(nAttr), 7 , nAttr)
    nAttr   :=IF( VALTYPE(nAttr)!="N", VAL(nAttr), nAttr)
    cPattern:=IF( EMPTY(cPattern), " ", cPattern)
    PatLen  :=LEN(cPattern)
    IF PatLen >= 18                              // Clipper limit
        Return(.F.)
    ELSE
        FOR jj = 1 to PatLen
            ShowPat +=SUBSTR(cPattern,jj,1)+CHR(nAttr)
        NEXT
    ENDIF
    IF PatLen = 1
        RestScreen( COORDS,  Replicate(ShowPat,(MaxCol()*2)*MaxRow()))
    ELSE
        RestScreen( COORDS,  Replicate(ShowPat, MaxCol()   *MaxRow()))
    ENDIF
Return(.T.)
#endif 

function ArraySkip(aLen, curPos, howMany)
    local actual
    if howMany >= 0
        if (curPos +howMany) > aLen
            actual := aLen - curPos
            curPos := aLen
        else
            actual := howMany
            curPos += howMany
        endif
    else
        if (curPos +howMany) < 1
            actual := 1 -curPos
            curPos := 1
        else
            actual := howMany
            curPos += howMany
        endif
    endif
return actual

function tbpanel
   *************************************************************************
   * Used to format the main TBrowse screen *
   *************************************************************************
   @0,0 say replicate(" ",80)                          color "w+/bg"
   dispbox(1, 0,maxrow()-1,38      ,B_DOUBLE+" ",            WHITEBLU )
   dispbox(1,39,maxrow()-1,maxcol(),B_DOUBLE+" ",            WHITEBLU )
   @2,42 say "Name"                                    color YELLOBLU
   @2,52 say CHR(179)                                  color WHITEBLU
   @2,54 say "Size"                                    color YELLOBLU
   @2,62 say CHR(179)                                  color WHITEBLU
   @2,64 say "Date"                                    color YELLOBLU
   @2,71 say CHR(179)                                  color WHITEBLU
   @2,73 say "Time"                                    color YELLOBLU
   @2,2  say PADC("DOS Version "+FT_DOSVER(),36)       color WHITEBLU
   @4,0  say "Ķ" color WHITEBLU 
   InfoBox()
return nil

*************************************
* created by Michael J. Riche' *
*************************************
STATIC FUNCTION RainHead()
    LOCAL TBTline := " The Clipper Commander, Version 1.1 "
    LOCAL XLEN    := LEN(TBTline)
    LOCAL nLen    := XLEN - 1
    LOCAL C       := ( (80-XLEN) / 2 )
    LOCAL R       := 0
    STATIC Colors := {'G+','BG','R+','B','G+','RB','R+','BG+','R','B+','G','RB+'}
    STATIC w      := 0
    STATIC nCnt   := 0

    SetPos(R,C ) ; ;
    DispOut( TBTline, "W+/BG")

    SetPos(R,C + nCnt ) ; ;
    DispOut( SUBSTR(TBTline, nCnt + 1, 1) , colors[++w % 12 + 1] + '/N')

    IF w > 11
        w := 0
    ENDIF

    IF (++nCnt > nLen)
        nCnt := 0
    ENDIF

RETURN (NIL)


function NoWayOut
return Tone(2000,1)

init function haha
   setcancel(.F.)
   setkey(K_ALT_C, {|| NoWayOut() } )
return nil

